pcl::MarchingCubes< PointNT > Class Template Referenceabstract
Module surface

The marching cubes surface reconstruction algorithm. More...

`#include <pcl/surface/marching_cubes.h>`

Inheritance diagram for pcl::MarchingCubes< PointNT >:

## Public Types

using | Ptr = shared_ptr< MarchingCubes< PointNT > >
using | ConstPtr = shared_ptr< const MarchingCubes< PointNT > >
using | PointCloudPtr = typename pcl::PointCloud< PointNT >::Ptr
using | KdTree = pcl::KdTree< PointNT >
using | KdTreePtr = typename KdTree::Ptr
Public Types inherited from pcl::SurfaceReconstruction< PointNT >
using | Ptr = shared_ptr< SurfaceReconstruction< PointNT > >
using | ConstPtr = shared_ptr< const SurfaceReconstruction< PointNT > >
Public Types inherited from pcl::PCLSurfaceBase< PointInT >
using | Ptr = shared_ptr< PCLSurfaceBase< PointInT > >
using | ConstPtr = shared_ptr< const PCLSurfaceBase< PointInT > >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| MarchingCubes (const float percentage_extend_grid=0.0f, const float iso_level=0.0f)
| Constructor. More...
| ~MarchingCubes ()
| Destructor. More...
void | setIsoLevel (float iso_level)
| Method that sets the iso level of the surface to be extracted. More...
float | getIsoLevel ()
| Method that returns the iso level of the surface to be extracted. More...
void | setGridResolution (int res_x, int res_y, int res_z)
| Method that sets the marching cubes grid resolution. More...
void | getGridResolution (int &res_x, int &res_y, int &res_z)
| Method to get the marching cubes grid resolution. More...
void | setPercentageExtendGrid (float percentage)
| Method that sets the parameter that defines how much free space should be left inside the grid between the bounding box of the point cloud and the grid limits. More...
float | getPercentageExtendGrid ()
| Method that gets the parameter that defines how much free space should be left inside the grid between the bounding box of the point cloud and the grid limits, as a percentage of the bounding box. More...
Public Member Functions inherited from pcl::SurfaceReconstruction< PointNT >
| SurfaceReconstruction ()
| Constructor. More...
| ~SurfaceReconstruction ()
| Destructor. More...
void | reconstruct (pcl::PolygonMesh &output) override
| Base method for surface reconstruction for all points given in <setInputCloud (), setIndices ()> More...
virtual void | reconstruct (pcl::PointCloud< PointNT > &points, std::vector< pcl::Vertices > &polygons)
| Base method for surface reconstruction for all points given in <setInputCloud (), setIndices ()> More...
Public Member Functions inherited from pcl::PCLSurfaceBase< PointInT >
| PCLSurfaceBase ()
| Empty constructor. More...
| ~PCLSurfaceBase ()
| Empty destructor. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide an optional pointer to a search object. More...
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used. More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()=default
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

virtual void | voxelizeData ()=0
| Convert the point cloud into voxel data. More...
void | interpolateEdge (Eigen::Vector3f &p1, Eigen::Vector3f &p2, float val_p1, float val_p2, Eigen::Vector3f &output)
| Interpolate along the voxel edge. More...
void | createSurface (const std::vector< float > &leaf_node, const Eigen::Vector3i &index_3d, pcl::PointCloud< PointNT > &cloud)
| Calculate out the corresponding polygons in the leaf node. More...
void | getBoundingBox ()
| Get the bounding box for the input data points. More...
virtual float | getGridValue (Eigen::Vector3i pos)
| Method that returns the scalar value at the given grid position. More...
void | getNeighborList1D (std::vector< float > &leaf, Eigen::Vector3i &index3d)
| Method that returns the scalar values of the neighbors of a given 3D position in the grid. More...
std::string | getClassName () const override
| Class get name method. More...
void | performReconstruction (pcl::PolygonMesh &output) override
| Extract the surface. More...
void | performReconstruction (pcl::PointCloud< PointNT > &points, std::vector< pcl::Vertices > &polygons) override
| Extract the surface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

std::vector< float > | grid_
| The data structure storing the 3D grid. More...
int | res_x_ = 32
| The grid resolution. More...
int | res_y_ = 32
int | res_z_ = 32
Eigen::Array3f | upper_boundary_
| bounding box More...
Eigen::Array3f | lower_boundary_
Eigen::Array3f | size_voxel_
| size of voxels More...
float | percentage_extend_grid_
| Parameter that defines how much free space should be left inside the grid between the bounding box of the point cloud and the grid limits, as a percentage of the bounding box. More...
float | iso_level_
| The iso level to be extracted. More...
Protected Attributes inherited from pcl::SurfaceReconstruction< PointNT >
bool | check_tree_
| A flag specifying whether or not the derived reconstruction algorithm needs the search object tree. More...
Protected Attributes inherited from pcl::PCLSurfaceBase< PointInT >
KdTreePtr | tree_
| A pointer to the spatial search object. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointNT>
class pcl::MarchingCubes< PointNT >

The marching cubes surface reconstruction algorithm.

This is an abstract class that takes a grid and extracts the isosurface as a mesh, based on the original marching cubes paper:

Lorensen W.E., Cline H.E., "Marching cubes: A high resolution 3d surface construction algorithm", SIGGRAPH '87

Author
  Alexandru E. Ichim

Definition at line 363 of file marching_cubes.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointNT >

using pcl::MarchingCubes< PointNT >::ConstPtr = shared_ptr<const MarchingCubes<PointNT> >

Definition at line 367 of file marching_cubes.h.

## KdTree

template<typename PointNT >

using pcl::MarchingCubes< PointNT >::KdTree = pcl::KdTree<PointNT>

Definition at line 374 of file marching_cubes.h.

## KdTreePtr

template<typename PointNT >

using pcl::MarchingCubes< PointNT >::KdTreePtr = typename KdTree::Ptr

Definition at line 375 of file marching_cubes.h.

## PointCloudPtr

template<typename PointNT >

using pcl::MarchingCubes< PointNT >::PointCloudPtr = typename pcl::PointCloud<PointNT>::Ptr

Definition at line 372 of file marching_cubes.h.

## Ptr

template<typename PointNT >

using pcl::MarchingCubes< PointNT >::Ptr = shared_ptr<MarchingCubes<PointNT> >

Definition at line 366 of file marching_cubes.h.

## Constructor & Destructor Documentation

## MarchingCubes()

template<typename PointNT >

pcl::MarchingCubes< PointNT >::MarchingCubes | ( | const float | percentage_extend_grid = `0.0f`,
|  | const float | iso_level = `0.0f`
| ) |  |

inline

Constructor.

Definition at line 378 of file marching_cubes.h.

## ~MarchingCubes()

template<typename PointNT >

pcl::MarchingCubes< PointNT >::~MarchingCubes

Destructor.

Definition at line 46 of file marching_cubes.hpp.

## Member Function Documentation

## createSurface()

template<typename PointNT >

void pcl::MarchingCubes< PointNT >::createSurface | ( | const std::vector< float > & | leaf_node,
|  | const Eigen::Vector3i & | index_3d,
|  | pcl::PointCloud< PointNT > & | cloud
| ) |  |

protected

Calculate out the corresponding polygons in the leaf node.

Parameters

  leaf_node | the leaf node to be checked
  index_3d | the 3d index of the leaf node to be checked
  cloud | point cloud to store the vertices of the polygon

Definition at line 83 of file marching_cubes.hpp.

References pcl::edgeTable, pcl::PointCloud< PointT >::push_back(), and pcl::triTable.

## getBoundingBox()

template<typename PointNT >

void pcl::MarchingCubes< PointNT >::getBoundingBox

protected

Get the bounding box for the input data points.

Definition at line 52 of file marching_cubes.hpp.

References pcl::getMinMax3D().

## getClassName()

template<typename PointNT >

std::string pcl::MarchingCubes< PointNT >::getClassName | ( |  | ) | const

inline override protected virtual

Class get name method.

Reimplemented from pcl::PCLSurfaceBase< PointInT >.

Definition at line 504 of file marching_cubes.h.

## getGridResolution()

template<typename PointNT >

void pcl::MarchingCubes< PointNT >::getGridResolution | ( | int & | res_x,
|  | int & | res_y,
|  | int & | res_z
| ) |  |

inline

Method to get the marching cubes grid resolution.

Parameters

  [in] | res_x | the resolution of the grid along the x-axis
  [in] | res_y | the resolution of the grid along the y-axis
  [in] | res_z | the resolution of the grid along the z-axis

Definition at line 416 of file marching_cubes.h.

References pcl::MarchingCubes< PointNT >::res_x_, pcl::MarchingCubes< PointNT >::res_y_, and pcl::MarchingCubes< PointNT >::res_z_.

## getGridValue()

template<typename PointNT >

float pcl::MarchingCubes< PointNT >::getGridValue | ( | Eigen::Vector3i | pos | ) |

protected virtual

Method that returns the scalar value at the given grid position.

Parameters

  [in] | pos | The 3D position in the grid

TODO what to return?

Definition at line 192 of file marching_cubes.hpp.

## getIsoLevel()

template<typename PointNT >

float pcl::MarchingCubes< PointNT >::getIsoLevel | ( |  | ) |

inline

Method that returns the iso level of the surface to be extracted.

Definition at line 398 of file marching_cubes.h.

References pcl::MarchingCubes< PointNT >::iso_level_.

## getNeighborList1D()

template<typename PointNT >

void pcl::MarchingCubes< PointNT >::getNeighborList1D | ( | std::vector< float > & | leaf,
|  | Eigen::Vector3i & | index3d
| ) |  |

protected

Method that returns the scalar values of the neighbors of a given 3D position in the grid.

Parameters

  [in] | index3d | the point in the grid
  [out] | leaf | the set of values

Definition at line 165 of file marching_cubes.hpp.

## getPercentageExtendGrid()

template<typename PointNT >

float pcl::MarchingCubes< PointNT >::getPercentageExtendGrid | ( |  | ) |

inline

Method that gets the parameter that defines how much free space should be left inside the grid between the bounding box of the point cloud and the grid limits, as a percentage of the bounding box.

Definition at line 433 of file marching_cubes.h.

References pcl::MarchingCubes< PointNT >::percentage_extend_grid_.

## interpolateEdge()

template<typename PointNT >

void pcl::MarchingCubes< PointNT >::interpolateEdge | ( | Eigen::Vector3f & | p1,
|  | Eigen::Vector3f & | p2,
|  | float | val_p1,
|  | float | val_p2,
|  | Eigen::Vector3f & | output
| ) |  |

protected

Interpolate along the voxel edge.

Parameters

  [in] | p1 | The first point on the edge
  [in] | p2 | The second point on the edge
  [in] | val_p1 | The scalar value at p1
  [in] | val_p2 | The scalar value at p2
  [out] | output | The interpolated point along the edge

Definition at line 70 of file marching_cubes.hpp.

## performReconstruction() [1/2]

template<typename PointNT >

void pcl::MarchingCubes< PointNT >::performReconstruction | ( | pcl::PointCloud< PointNT > & | points,
|  | std::vector< pcl::Vertices > & | polygons
| ) |  |

override protected virtual

Extract the surface.

Parameters

  [out] | points | the points of the extracted mesh
  [out] | polygons | the connectivity between the point of the extracted mesh.

Implements pcl::SurfaceReconstruction< PointNT >.

Definition at line 220 of file marching_cubes.hpp.

References pcl::PointCloud< PointT >::clear(), pcl::PointCloud< PointT >::points, pcl::PointCloud< PointT >::reserve(), pcl::PointCloud< PointT >::size(), pcl::PointCloud< PointT >::swap(), and pcl::Vertices::vertices.

## performReconstruction() [2/2]

template<typename PointNT >

void pcl::MarchingCubes< PointNT >::performReconstruction | ( | pcl::PolygonMesh & | output | ) |

override protected virtual

Extract the surface.

Parameters

  [out] | output | the resultant polygonal mesh

Implements pcl::SurfaceReconstruction< PointNT >.

Definition at line 208 of file marching_cubes.hpp.

References pcl::PolygonMesh::cloud, pcl::PolygonMesh::polygons, and pcl::toPCLPointCloud2().

## setGridResolution()

template<typename PointNT >

void pcl::MarchingCubes< PointNT >::setGridResolution | ( | int | res_x,
|  | int | res_y,
|  | int | res_z
| ) |  |

inline

Method that sets the marching cubes grid resolution.

Parameters

  [in] | res_x | the resolution of the grid along the x-axis
  [in] | res_y | the resolution of the grid along the y-axis
  [in] | res_z | the resolution of the grid along the z-axis

Definition at line 407 of file marching_cubes.h.

References pcl::MarchingCubes< PointNT >::res_x_, pcl::MarchingCubes< PointNT >::res_y_, and pcl::MarchingCubes< PointNT >::res_z_.

## setIsoLevel()

template<typename PointNT >

void pcl::MarchingCubes< PointNT >::setIsoLevel | ( | float | iso_level | ) |

inline

Method that sets the iso level of the surface to be extracted.

Parameters

  [in] | iso_level | the iso level.

Definition at line 393 of file marching_cubes.h.

References pcl::MarchingCubes< PointNT >::iso_level_.

## setPercentageExtendGrid()

template<typename PointNT >

void pcl::MarchingCubes< PointNT >::setPercentageExtendGrid | ( | float | percentage | ) |

inline

Method that sets the parameter that defines how much free space should be left inside the grid between the bounding box of the point cloud and the grid limits.

Does not affect the resolution of the grid, it just changes the voxel size accordingly.

Parameters

  [in] | percentage | the percentage of the bounding box that should be left empty between the bounding box and the grid limits.

Definition at line 426 of file marching_cubes.h.

References pcl::MarchingCubes< PointNT >::percentage_extend_grid_.

## voxelizeData()

template<typename PointNT >

virtual void pcl::MarchingCubes< PointNT >::voxelizeData | ( |  | ) |

protected pure virtual

Convert the point cloud into voxel data.

Implemented in pcl::MarchingCubesRBF< PointNT >, and pcl::MarchingCubesHoppe< PointNT >.

## Member Data Documentation

## grid_

template<typename PointNT >

std::vector<float> pcl::MarchingCubes< PointNT >::grid_

protected

The data structure storing the 3D grid.

Definition at line 438 of file marching_cubes.h.

## iso_level_

template<typename PointNT >

float pcl::MarchingCubes< PointNT >::iso_level_

protected

The iso level to be extracted.

Definition at line 455 of file marching_cubes.h.

Referenced by pcl::MarchingCubes< PointNT >::getIsoLevel(), and pcl::MarchingCubes< PointNT >::setIsoLevel().

## lower_boundary_

template<typename PointNT >

Eigen::Array3f pcl::MarchingCubes< PointNT >::lower_boundary_

protected

Definition at line 445 of file marching_cubes.h.

## percentage_extend_grid_

template<typename PointNT >

float pcl::MarchingCubes< PointNT >::percentage_extend_grid_

protected

Parameter that defines how much free space should be left inside the grid between the bounding box of the point cloud and the grid limits, as a percentage of the bounding box.

Definition at line 452 of file marching_cubes.h.

Referenced by pcl::MarchingCubes< PointNT >::getPercentageExtendGrid(), and pcl::MarchingCubes< PointNT >::setPercentageExtendGrid().

## res_x_

template<typename PointNT >

int pcl::MarchingCubes< PointNT >::res_x_ = 32

protected

The grid resolution.

Definition at line 441 of file marching_cubes.h.

Referenced by pcl::MarchingCubes< PointNT >::getGridResolution(), and pcl::MarchingCubes< PointNT >::setGridResolution().

## res_y_

template<typename PointNT >

int pcl::MarchingCubes< PointNT >::res_y_ = 32

protected

Definition at line 441 of file marching_cubes.h.

Referenced by pcl::MarchingCubes< PointNT >::getGridResolution(), and pcl::MarchingCubes< PointNT >::setGridResolution().

## res_z_

template<typename PointNT >

int pcl::MarchingCubes< PointNT >::res_z_ = 32

protected

Definition at line 441 of file marching_cubes.h.

Referenced by pcl::MarchingCubes< PointNT >::getGridResolution(), and pcl::MarchingCubes< PointNT >::setGridResolution().

## size_voxel_

template<typename PointNT >

Eigen::Array3f pcl::MarchingCubes< PointNT >::size_voxel_

protected

size of voxels

Definition at line 448 of file marching_cubes.h.

## upper_boundary_

template<typename PointNT >

Eigen::Array3f pcl::MarchingCubes< PointNT >::upper_boundary_

protected

bounding box

Definition at line 444 of file marching_cubes.h.

The documentation for this class was generated from the following files:

- pcl/surface/marching_cubes.h
- pcl/surface/impl/marching_cubes.hpp